#include <stdio.h>
#include <stdlib.h>

#define QUEEN	'O'
#define BLANK	' '

static short *matrix;

#define posto(k,i,j)	((k) * (i) + (j))

void stampa(short N)
{
	short i,j;

	for(i = 0; i < N; i++) {
		for(j = 0; j < N; j++)
			printf("[%c]",matrix[posto(N,i,j)] ? QUEEN : BLANK);
		putchar('\n');
	}
	putchar('\n');
}

char checkrow(short N, short i, short j)
{
	short k;

	for(k = 0; k < i; k++)
		if(matrix[posto(N,k,j)])
			return 0;
	return 1;
}

char checkdiag(short N, short i, short j)
{
	short k;

	for(k = 0; k < i; k++)
		if(((j-i+k >= 0) && matrix[posto(N,k,j-i+k)]) || ((j+i-k < N) && matrix[posto(N,k,j+i-k)]))
			return 0;
	return 1;
}


char backtrack(short N, short x, short y)
{
	short xx,yy;

	if(x == N - 1)
		return 1;
	for(yy = 0; yy < N; yy++) {
		if(y == yy)
			continue;
		if(checkrow(N,xx = x + 1,yy) && checkdiag(N,xx,yy)) {
			matrix[posto(N,xx,yy)] = 1;
			if(backtrack(N,xx,yy))
				return 1;			
		}
	}
	matrix[posto(N,x,y)] = 0;
	return 0;
}

int main(void)
{
	short y,N;

	printf("Immetti lato:\n");
	scanf("%hd",&N);

	if(!(matrix = calloc(N * N, sizeof(short)))) {
		fprintf(stderr, "Errore nell'allocazione della memoria\n");
		return -1;
	}
	for(y = 0; y < N; y++) {
		matrix[posto(N,0,y)] = 1;
		if(backtrack(N,0,y))
			break;
	}
	stampa(N);
	return 0;
}
