#include <stdio.h>

#define N	8

#define QUEEN	'O'
#define BLANK	' '

static short matrix[N][N];

void stampa()
{
	short i,j;

	for(i = 0; i < N; i++) {
		for(j = 0; j < N; j++)
			printf("[%c]",matrix[i][j] ? QUEEN : BLANK);
		putchar('\n');
	}
	putchar('\n');
}

char checkrow(short i, short j)
{
	short k;

	for(k = 0; k < i; k++)
		if(matrix[k][j])
			return 0;
	return 1;
}

char checkdiag(short i, short j)
{
	short k;

	for(k = 0; k < i; k++)
		if(((j-i+k >= 0) && matrix[k][j-i+k]) || ((j+i-k < N) && matrix[k][j+i-k]))
			return 0;
	return 1;
}


char backtrack(short x, short y)
{
	short xx,yy;

	if(x == N - 1)
		return 1;
	for(yy = 0; yy < N; yy++) {
		if(y == yy)
			continue;
		if(checkrow(xx = x + 1,yy) && checkdiag(xx,yy)) {
			matrix[xx][yy] = 1;
			if(backtrack(xx,yy))
				return 1;			
		}
	}
	matrix[x][y] = 0;
	return 0;
}

int main(void)
{
	short y;

	for(y = 0; y < N; y++) {
		matrix[0][y] = 1;
		if(backtrack(0,y))
			break;
	}
	stampa();
	return 0;
}
