#include <stdio.h>

#define N	8

#define QUEEN	'O'
#define BLANK	' '

#define MSG		"Soluzione %d:\n"

short matrix[N][N];

void stampa(int nsol)
{
	short i,j;

	printf(MSG,nsol);
	for(i = 0; i < N; i++) {
		for(j = 0; j < N; j++)
			printf("[%c]",matrix[i][j] ? QUEEN : BLANK);
		putchar('\n');
	}
	putchar('\n');
}

char checkrow(short i, short j)
{
	short k;

	for(k = 0; k < i; k++)
		if(matrix[k][j])
			return 0;
	return 1;
}

char checkdiag(short i, short j)
{
	short k;

	for(k = 0; k < i; k++)
		if(((j-i+k >= 0) && matrix[k][j-i+k]) || ((j+i-k < N) && matrix[k][j+i-k]))
			return 0;
	return 1;
}

int backtrack(short x, short y, int nsol)
{
	short xx,yy;

	if(x == N - 1)
		stampa(++nsol);
	else {
		for(yy = 0; yy < N; yy++) {
			if(y == yy)
				continue;
			if(checkrow(xx = x + 1,yy) && checkdiag(xx,yy)) {
				matrix[xx][yy] = 1;
				nsol = backtrack(xx,yy,nsol);		
			}
		}
	}
	matrix[x][y] = 0;
	return nsol;
}

int main(void)
{
	short y;
	int nsol = 0;

	for(y = 0; y < N; y++) {
		matrix[0][y] = 1;
		nsol = backtrack(0,y,nsol);
	}
	return 0;
}
