#include <stdio.h>
#include <stdlib.h>

#define MAXDIM 20

/* inizializza l'array con la permutazione identica (a[i] = i) */
void inizializza(int *a, int n)
{
	int i;

	for(i = 0; i < n; i++)
		a[i] = i;
}

void stampa(int *a, int n)
{
	int i;

	for(i = 0; i < n; i++)
		printf("%3d ",a[i]);
	putchar('\n');
}

void swap(int *a, int *b)
{
	int tmp = *a;

	*a = *b;
	*b = tmp;
}


/* calcola e stampa le permutazioni degli elementi di a dall'indice l all'indice n-1 */
void perm(int *a, int l, int n)
{
	int i;

	/* condizione di terminazione: se l == n-1, il sottoarray ha un solo elemento */
	/* e non c'e' nulla da fare a parte stamparlo */
	if(l == n - 1) {
		stampa(a,n);
		return;
	}
	/* sostituisco l'ellesimo elemento di a in tutti i modi */
	/* cioe' per ogni i = l,...,n-1, scambio a[l] con a[i] */
	for(i = l; i < n; i++) {
		swap(&a[l],&a[i]);
		/* calcolo tutte le permutazioni del sottoarray a[l+1],...,a[n] */
		perm(a,l + 1,n);
		/* Rieffettuo lo scambio in modo tale che */
		/* l'array a abbia gli elementi nello stesso ordine */
		/* in cui erano al momento dello swap precedente */
		swap(&a[l],&a[i]); 
	}
	/* alla fine dell'esecuzione */
	/* l'ordine degli elementi di a e' identico a quello iniziale */
	/* Provare ad aggiungere nel main "stampa(a,n);" dopo "perm(a,0,n);" */
}

int main(void)
{
	int a[MAXDIM];
	int n;

	printf("Immetti n:");
	scanf("%d",&n);

	inizializza(a,n);

	perm(a,0,n);

	return 0;
}
